/**
 * @typedef {import('interface-datastore').Datastore} Datastore
 * @typedef {import('interface-datastore').Key} Key
 * @typedef {import('interface-datastore').Options} Options
 * @typedef {import('interface-datastore').Batch} Batch
 * @typedef {import('interface-datastore').Query} Query
 * @typedef {import('interface-datastore').KeyQuery} KeyQuery
 * @typedef {import('./types').KeyTransform} KeyTransform
 */
/**
 * A datastore that can combine multiple stores inside various
 * key prefixes
 *
 * @implements {Datastore}
 */
export class MountDatastore extends BaseDatastore implements Datastore {
    /**
     * @param {Array<{prefix: Key, datastore: Datastore}>} mounts
     */
    constructor(mounts: Array<{
        prefix: Key;
        datastore: Datastore;
    }>);
    mounts: {
        prefix: Key;
        datastore: Datastore;
    }[];
    /**
     * Lookup the matching datastore for the given key
     *
     * @private
     * @param {Key} key
     * @returns {{datastore: Datastore, mountpoint: Key} | undefined}
     */
    private _lookup;
}
export type Datastore = import('interface-datastore').Datastore;
export type Key = import('interface-datastore').Key;
export type Options = import('interface-datastore').Options;
export type Batch = import('interface-datastore').Batch;
export type Query = import('interface-datastore').Query;
export type KeyQuery = import('interface-datastore').KeyQuery;
export type KeyTransform = import('./types').KeyTransform;
import { BaseDatastore } from "./base.js";
//# sourceMappingURL=mount.d.ts.map