/**
 * Convert a given string to the matching sharding function.
 *
 * @param {string} str
 * @returns {Shard}
 */
export function parseShardFun(str: string): Shard;
/**
 * @typedef {import('interface-datastore').Datastore} Datastore
 * @typedef {import('./types').Shard} Shard
 */
export const PREFIX: "/repo/flatfs/shard/";
export const SHARDING_FN: "SHARDING";
export const README_FN: "_README";
/**
 * @implements {Shard}
 */
export class ShardBase implements Shard {
    /**
     * @param {any} param
     */
    constructor(param: any);
    param: any;
    name: string;
    _padding: string;
    /**
     * @param {string} s
     */
    fun(s: string): string;
    toString(): string;
}
/**
 * @implements {Shard}
 */
export class Prefix extends ShardBase implements Shard {
    /**
     * @param {number} prefixLen
     */
    constructor(prefixLen: number);
}
export class Suffix extends ShardBase {
    /**
     * @param {number} suffixLen
     */
    constructor(suffixLen: number);
}
export class NextToLast extends ShardBase {
    /**
     * @param {number} suffixLen
     */
    constructor(suffixLen: number);
}
export function readShardFun(path: string | Uint8Array, store: Datastore): Promise<import("./types").Shard>;
export { default as readme } from "./shard-readme.js";
export type Datastore = import('interface-datastore').Datastore;
export type Shard = import('./types').Shard;
//# sourceMappingURL=shard.d.ts.map