import { Key } from 'interface-datastore';
import { KeyTransformDatastore } from './keytransform.js';
export class NamespaceDatastore extends KeyTransformDatastore {
  constructor(child, prefix) {
    super(child, {
      convert(key) {
        return prefix.child(key);
      },
      invert(key) {
        if (prefix.toString() === '/') {
          return key;
        }
        if (!prefix.isAncestorOf(key)) {
          throw new Error(`Expected prefix: (${ prefix.toString() }) in key: ${ key.toString() }`);
        }
        return new Key(key.toString().slice(prefix.toString().length), false);
      }
    });
  }
}